## gnat-gps 1.4.0

=== common/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.common $@ ADA_SOURCES="test_htables.adb test_debug.adb"

=== kernel/src_info/Makefile ===
GNATMAKE_FLAGS=
LARGS = -aO../../gvd/gnat -largs sn/lib/db_capi.o -Lsn/snsrc/db/PORT -ldb ../../gvd/common/obj/gexpect_tty.o

CP=cp -p

build:
	cd standalone_obj; gcc -c ../common/file-utils.c
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone read_ali $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone read_many_ali $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone read_ali_twice $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone read_scope_tree $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone find_ref $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone find_local_ref $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone find_dep $(LARGS) `gtkada-config`
	gnatmake -m -a ${GNATMAKE_FLAGS} -Pstandalone generate_db $(LARGS) `gtkada-config`

distrib:
	@-mkdir -p gvd gnat > /dev/null 2>&1
	$(CP) ../../common/src/sdefault.adb common
	$(CP) ../../gvd/common/file_utils.ad? common
	$(CP) ../../gvd/common/file-utils.c common
	$(CP) ../../gvd/common/htables.ad? common
	$(CP) ../../gvd/common/string_hash.ad? common
	$(CP) ../../gvd/common/traces.ad? common
	$(CP) ../../gvd/common/basic_types.ad? gvd
	$(CP) ../../gvd/common/os_utils.ad? gvd
	$(CP) ../../gvd/common/vfs.ad? gvd
	$(CP) ../../gvd/common/remote_connections.ad? gvd
	$(CP) ../../gvd/common/string_utils.ad? gvd
	$(CP) ../../gvd/common/language_handlers.ad? gvd
	$(CP) ../../gvd/common/language-unknown.ad? gvd
	$(CP) ../../gvd/common/language.ad? gvd
	$(CP) ../../gvd/common/odd_intl.ad? gvd
	$(CP) ../../ada_module/src/src_info-* common
	$(CP) ../../cpp_module/src/src_info-* common
	$(CP) ../../gvd/gnat/g-exptty.ad? gvd
	$(CP) ../../gvd/gnat/g-tty.ad? gvd
	$(CP) ../../gvd/gnat/gexpect_tty.c gvd
	$(CP) ../../gnat/*.ad? gnat

clean:
	@for i in standalone_obj/* ; do [ -f $$i ] && rm -f $$i || true; done
force:

=== tools/project_converter/Makefile ===
all: force
	gnatmake -Pconvert
force:

## gnat-gps 2.1.0

=== common/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.common $@ ADA_SOURCES="test_htables.adb test_rbtree.adb test_trie.adb test_arrays.adb"

=== glide/Makefile ===
SO_EXT = .so

default build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.gps $@

shared: compile do-shared restore

do-shared:
# prepare the objects for the shared library:
	for m in ../kernel .. ../common ../widgets ../gvd ../gvd/common ../vsearch; do \
	  mkdir -p $$m/obj_save; \
	  mv $$m/obj/*.o $$m/obj_save; \
	  chmod -w $$m/obj/*.ali; \
	  for l in `ls $$m/obj/lib*.a 2> /dev/null`; do \
	    for f in `ar t $$l`; do \
	      mv $$m/obj_save/$$f $$m/obj; \
	    done \
	  done \
	done

# restore gvd_module:
	mv ../gvd/obj_save/gvd_module*.o ../gvd/obj

# create libkernel.so that includes the following projects:
# kernel, gnat, common, widgets, gvd, gvd_common, vsearch

	cd ../kernel/obj; gcc -shared -o libkernel$(SO_EXT) ../obj_save/*.o \
	  ../../obj_save/*.o ../../common/obj_save/*.o \
	  ../../widgets/obj_save/*.o ../../gvd/obj_save/*.o \
	  ../../gvd/common/obj_save/*.o ../../vsearch/obj_save/*.o

# rebind/link gps with libkernel.so:
	-rm -f obj/gps
	$(MAKE) -s -f Makefile.gps default ADAFLAGS="-largs -lkernel"

restore:
# put back objects and ali files in their original state:
	for m in ../kernel .. ../common ../widgets ../gvd ../gvd/common ../vsearch; do \
	  mv $$m/obj_save/*.o $$m/obj; \
	  rmdir $$m/obj_save; \
	  chmod +w $$m/obj/*.ali; \
	done

=== gvd/Makefile ===
CFLAGS = -g -O2
TARGET =

subdirs= pixmaps gnat gvd po tests docs

install_subdirs=${subdirs:%=install_%}
clean_subdirs=${subdirs:%=clean_%}
mostly_clean_subdirs=${subdirs:%=mclean_%}
distclean_subdirs=${subdirs:%=distclean_%}
maintainer_clean_subdirs=${subdirs:%=maintainer_clean_%}

.PHONY: all install clean mostlyclean distclean maintainer_clean

all: ${subdirs}
${subdirs}: force
	$(MAKE) CFLAGS="$(CFLAGS)" -C $@ $(TARGET)

static:
	$(MAKE) TARGET=$@

install: ${install_subdirs}
${install_subdirs}: force
	$(MAKE) -C ${@:install_%=%} install

clean-generic: force
	-$(RM) core
	-$(RM) .\#*
clean: ${clean_subdirs} force
${clean_subdirs}: force
	${MAKE} -C ${@:clean_%=%} clean

mostlyclean-generic: clean-generic
mostlyclean: mostlyclean-generic ${mostly_clean_subdirs}
${mostly_clean_subdirs}: force
	${MAKE} -C ${@:mclean_%=%} mostlyclean

distclean-generic: mostlyclean-generic force
	-$(RM) config.cache config.log config.status
distclean: distclean-generic ${distclean_subdirs}
${distclean_subdirs}: force
	${MAKE} -C ${@:distclean_%=%} distclean

maintainer-clean: distclean-generic ${maintainer_clean_subdirs} force
	-$(RM) configure
${maintainer_clean_subdirs}: force
	${MAKE} -C ${@:maintainer_clean_%=%} maintainer_clean

force:

=== tools/custom_converter/Makefile ===
all:
	gnatmake -Pcustom_convert -largs `gtkada-config --libs`

=== tools/project_converter/Makefile ===
all: force
	gnatmake -Pconvert -largs ../../common/obj/libcommon.a
force:

=== vsearch/tests/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.vsearch_tests $@

=== widgets/cschtml/Makefile ===
all: cscmarshal.h cscmarshal.c

cscmarshal.h: cschtml.list
	glib-genmarshal --prefix=cschtml --header $< > $@

cscmarshal.c: cschtml.list
	glib-genmarshal --prefix=cschtml --body $< > $@

=== widgets/tests/Makefile ===
# List of C files to compile
C_FILES=${GVDCOMMON_SRC}/pixmaps/pixmaps.c
OBJ_DIR=.

# Main file(s) to compile
MAIN=run_test_file_selector

# List of modules we depend on (Check ../../Makefile.common for list of
# supported modules)
MODULES=debugger_common gtkada

include ../../Makefile.common

## gnat-gps 3.1.3

=== common/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.common $@ ADA_SOURCES="test_htables.adb test_rbtree.adb test_arrays.adb test_strings.adb"

=== common/sal/Makefile ===
#USAGE: make [CC=<compiler>] JAVA_SDK=<path>
CC=gcc

ifeq ($(OS),Windows_NT)
	JAVA_OS_DIR=win32
else
	ifeq ($(OSTYPE),solaris)
		JAVA_OS_DIR=solaris
	else
		JAVA_OS_DIR=linux
	endif
endif

main:
	cd obj; $(CC) -fPIC -I$(JAVA_SDK)/include -I$(JAVA_SDK)/include/$(JAVA_OS_DIR) -c ../jni_wrappers.c 
	$(RM) lib/*gps_utils*
	gnatmake -Psal

## gnat-gps 4.0.1

=== action_editor/Makefile ===
ada compile link c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.action_editor $@

=== ada_module/Makefile ===
ada compile link c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.vsearch $@

=== aliases/Makefile ===
ada compile link c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.aliases $@

=== aunit/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.aunit $@

=== browsers/Makefile ===
ada compile link c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.browsers $@

=== codefix/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.codefix $@

=== common/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.common $@ ADA_SOURCES="test_htables.adb test_arrays.adb test_strings.adb test_trie.adb"

=== custom/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.custom $@

=== gbuilder/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.gbuilder $@ ADA_SOURCES="gbuilder.adb radical.adb"

=== gps/Makefile ===
export TP_TASKING = No_Tasking

default build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.gps $@

=== kernel/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.kernel $@

test:
	$(MAKE) -s -f Makefile.kernel ADA_SOURCES=read_ali.adb build

=== keymanager/Makefile ===
ada compile link c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.keymanager $@

## gnat-gps 4.3~2008.08.09ubuntu1

=== corelib/Makefile ===
.PHONY: all examples tests valgrind clean docs

all tests examples valgrind clean docs:
	${MAKE} -C scripts $@

=== gnatlib/Makefile ===
.PHONY: all examples test valgrind clean docs install

include Makefile.conf

ifeq (${BUILDS_SHARED},yes)
all: static relocatable
install: install_relocatable install_static
else
all: static
install: install_static
endif

## Builds explicitly the shared or the static libraries

static:
	${MAKE} LIBRARY_TYPE=static build_library_type
shared relocatable:
	${MAKE} LIBRARY_TYPE=relocatable build_library_type

## Builds either the static or the shared version, based on the
## LIBRARY_TYPE variable

build_library_type:
	${MAKE} -C src -f Makefile.gnatcoll
	${MAKE} -C src -f Makefile.python
ifeq (${WITH_GTK},yes)
	${MAKE} -C src -f Makefile.gtk
endif
	${MAKE} -C src -f Makefile.postgres
	$(MAKE) -C src -f Makefile.tools

examples:
	${MAKE} -C examples

## Only works after installation, so we should install to a local directory
## first, so as not to break the users's environment, but still test the
## actual installation process.
## However, we do not force a recompilation here for now, so that we can still
## run the tests on the current binaries, even if we are doing some modifs
## that are not yet compilable
test: 
	${MAKE} prefix=${shell pwd}/local_install install >/dev/null
	${MAKE} prefix=${shell pwd}/local_install -C testsuite $@

## GNU standards say we must not recompile in such a case
## Install either the static or the shared lib, based on the value of
## LIBRARY_TYPE
install_library_type:
	${MKDIR} ${bindir}
	${MKDIR} ${libdir}/${TARNAME}/${LIBRARY_TYPE}
	${MKDIR} ${libdir}/gnat/${TARNAME}
	${MKDIR} ${datadir}/examples
	${MKDIR} ${includedir}/${TARNAME}
	${MKDIR} ${datadir}/gps/plug-ins
	${MAKE} -C src -f Makefile.gnatcoll install
	${MAKE} -C src -f Makefile.python install
	${MAKE} -C docs install
ifeq (${WITH_GTK},yes)
	${MAKE} -C src -f Makefile.gtk install
endif
	${MAKE} -C src -f Makefile.postgres install
	${MAKE} -C src -f Makefile.tools install
	${INSTALL} distrib/gnatcoll_gps.xml ${datadir}/gps/plug-ins
	${CP} distrib/*.gpr ${libdir}/gnat

install_static:
	${MAKE} LIBRARY_TYPE=static install_library_type
install_relocatable install_shared:
	${MAKE} LIBRARY_TYPE=relocatable install_library_type

clean:
	${MAKE} LIBRARY_TYPE=relocatable -C src -f Makefile.gnatcoll $@
	${MAKE} LIBRARY_TYPE=static      -C src -f Makefile.gnatcoll $@
	${MAKE} LIBRARY_TYPE=relocatable -C src -f Makefile.python $@
	${MAKE} LIBRARY_TYPE=static      -C src -f Makefile.python $@
ifeq (${WITH_GTK},yes)
	${MAKE} LIBRARY_TYPE=relocatable -C src -f Makefile.gtk $@
	${MAKE} LIBRARY_TYPE=static     -C src -f Makefile.gtk $@
endif
	${MAKE} LIBRARY_TYPE=relocatable -C src -f Makefile.postgres $@
	${MAKE} LIBRARY_TYPE=static     -C src -f Makefile.postgres $@
	${MAKE} LIBRARY_TYPE=relocatable -C src -f Makefile.tools $@
	${MAKE} LIBRARY_TYPE=static     -C src -f Makefile.tools $@
	${MAKE} -C testsuite $@
	${MAKE} -C docs $@
	${MAKE} -C examples $@

docs:
	${MAKE} -C docs

=== prj_editor/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.prj_editor $@

=== src_editor/Makefile ===
all build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.src_editor $@

=== corelib/docs/Makefile ===
MAKEINFO=makeinfo
TEXI2DVI=texi2dvi

corelib.html: corelib.texi
	${MAKEINFO} --html --css-include=corelib.css --number-sections $<

corelib.pdf: corelib.texi
	echo x | ${TEXI2DVI} -p $<

corelib.txt: corelib.texi
	${MAKEINFO} --force --no-headers --no-split -o $@ $<

.PHONY: clean-temp-files
clean-temp-files:
	-$(RM) *.aux
	-$(RM) *.cp
	-$(RM) *.cps
	-$(RM) *.fn
	-$(RM) *.ky
	-$(RM) *.log
	-$(RM) *.pg
	-$(RM) *.toc
	-$(RM) *.tp
	-$(RM) *.vr

.PHONY: clean
clean: clean-temp-files
	-${RM} corelib.pdf corelib.txt
	-${RM} -rf corelib/

=== corelib/scripts/Makefile ===
include ../Makefile.conf

## Current versions of gprmake have no way to build all sources of a
## given project. It doesn't really matter, we just build the examples
## directly. or we could do a "gnatmake -u", followed by "gprmake"

all_text:
	gnatmake -u -Pcorelib_scripts
	gprmake -Pcorelib_scripts
all_gtk:
	gnatmake -u -Pcorelib_scripts_gtk
	gprmake -Pcorelib_scripts_gtk
examples_text:
	gprmake -q -Pexamples/examples
examples_gtk:
	gprmake -q -Pexamples/examplesgtk
tests:
	gprmake -q -Ptestsuite/testsuite
	cd testsuite && ./run.sh
valgrind:
	@VALGRIND=yes ${MAKE} tests
clean_text:
	gnatclean -r -q -Ptestsuite/testsuite
	gnatclean -r -q -Pexamples/examples
clean_gtk:
	gnatclean -r -q -Pexamples/examplesgtk
docs:
	${MAKE} -C docs

=== gnatlib/docs/Makefile ===
MAKEINFO=makeinfo
TEXI2DVI=texi2dvi

gnatlib.html: gnatlib.texi
	${MAKEINFO} --html --css-include=gnatlib.css --number-sections $<

gnatlib.pdf: gnatlib.texi
	echo x | ${TEXI2DVI} -p $<

gnatlib.txt: gnatlib.texi
	${MAKEINFO} --force --no-headers --no-split -o $@ $<

.PHONY: clean-temp-files
clean-temp-files:
	-$(RM) *.aux
	-$(RM) *.cp
	-$(RM) *.cps
	-$(RM) *.fn
	-$(RM) *.ky
	-$(RM) *.log
	-$(RM) *.pg
	-$(RM) *.toc
	-$(RM) *.tp
	-$(RM) *.vr

.PHONY: clean
clean: clean-temp-files
	-${RM} gnatlib.pdf gnatlib.txt
	-${RM} -rf gnatlib/

=== gnatlib/scripts/Makefile ===
include ../Makefile.conf


ifeq (${WITH_GTK},yes)
all:      all_text all_gtk
examples: examples_text examples_gtk
clean:    clean_text    clean_gtk
else
all:      all_text
examples: examples_text
clean:    clean_text
endif

## Current versions of gprmake have no way to build all sources of a
## given project. It doesn't really matter, we just build the examples
## directly. or we could do a "gnatmake -u", followed by "gprmake"

all_text: obj/python_support.o
	gnatmake -q -u -Pgnatlib_scripts
all_gtk: obj/python_support_gtk.o
	gnatmake -q -u -Pgnatlib_scripts_gtk

ifeq ($(WITH_PYTHON),yes)
obj/python_support.o: src/python/python_support.c
	gcc -c ${PYTHON_CFLAGS} $< -o $@
obj/python_support_gtk.o: src_gtk/python/python_support_gtk.c
	gcc -c ${PYTHON_CFLAGS} ${PYGTK_INCLUDE} ${GTK_INCLUDE} $< -o $@
else
obj/python_support.o:
obj/python_support_gtk.o:
endif


examples_text:
	gprmake -q -Pexamples/examples
examples_gtk:
	gprmake -q -Pexamples/examplesgtk
tests:
	gprmake -q -Ptestsuite/testsuite
	cd testsuite && ./run.sh
valgrind:
	@VALGRIND=yes ${MAKE} tests
clean_text:
	gnatclean -r -q -Ptestsuite/testsuite
	gnatclean -r -q -Pexamples/examples
clean_gtk:
	gnatclean -r -q -Pexamples/examplesgtk
docs:
	${MAKE} -C docs

=== gnatlib/src/Makefile ===
include ../Makefile.conf

.PHONY: all clean examples tests valgrind

all:
	gnatmake -q -u -Pgnatlib_src

clean:
	gnatclean -r -q -Pgnatlib_src

examples:

tests:

valgrind:

=== gnatlib/testsuite/Makefile ===
test:
include ../Makefile.conf

ADA_PROJECT_PATH:=${prefix}/lib/gnat${DIRSEP}${ADA_PROJECT_PATH}${DIRSEP}../src
LD_LIBRARY_PATH:=${prefix}/lib:${LD_LIBRARY_PATH}
export ADA_PROJECT_PATH
export LD_LIBRARY_PATH

test:
	@${MKDIR} obj
	@GNATLIB_LIBRARY_TYPE=${GNATLIB_LIBRARY_TYPE} ./run.sh
clean:
	gnatclean -q -Ptest_traces -XGNATLIB_LIBRARY_TYPE=${GNATLIB_LIBRARY_TYPE}

=== kernel/src_info/sn/Makefile ===
all: snsrc src

snsrc:
	$(MAKE) -C snsrc

src:
	$(MAKE) -C src

clean:
	$(MAKE) -C src clean
	$(MAKE) -C snsrc clean

distclean:
	$(RM) Makefile config.cache include/config.h config.log config.status
	$(MAKE) -C src distclean
	$(MAKE) -C snsrc distclean

.PHONY: snsrc src distclean

=== debian/changelog ===
gnat-gps (4.3~2008.08.09ubuntu1) intrepid; urgency=low

  * Add lpia to supported architectures.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Mon, 18 Aug 2008 12:35:49 +0000

gnat-gps (4.3~2008.08.09) unstable; urgency=low
  
  * New version from upstream's Subversion repository, revision 127639.
  * Build with GCC 4.3 and GtkAda 2.12. Closes: #445772, #468310.
  * Add support for mips, mipsel and ppc64.
  * Transition from python2.4 to whatever new version of Python is the
    default.  Closes: #493850.
  * patches/gcc-4.3.patch: new; adjust to GCC 4.3.
  * patches/bashisms.patch: new.
  * patches/gcc-4.1.patch,
    patches/gtkada-2.8.1.patch,
    patches/memory-corruption.patch,
    patches/python-customisation.patch: delete, obsolete.
  * patches/*.patch: adjust to the new upstream version.

 -- Ludovic Brenta <lbrenta@debian.org>  Wed, 13 Aug 2008 16:07:09 +0200
  

gnat-gps (4.0.1-6) unstable; urgency=low
  
  * debian/control: build-depend-indep on texlive-generic-recommended,
    too.  Closes: #443030.  Thanks to Cyril Brulebois for investigating.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 29 Sep 2007 14:46:34 +0200

gnat-gps (4.0.1-5) unstable; urgency=low
  
  * debian/control: build-depend-indep on texlive-latex-base.
    Closes: #436368.

 -- Ludovic Brenta <lbrenta@debian.org>  Wed, 22 Aug 2007 21:46:27 +0200

gnat-gps (4.0.1-4) unstable; urgency=low
  
  * debian/rules: install the HTML documentation generated from gps.texi.
    Closes: #423231.
  * patches/command-names.patch: apply fix from Teemu Ikonen.  Thanks!
    Closes: #435544.
  * patches/command-names.patch (gvd-process.adb): change the default
    debugger command to gnatgdb.  Closes: #414614.  Also fix a typo.
  * debian/control: transition to tetex-live.
  * patches/gtkada-2.8.1.patch: adjust to 2.8.1-6, replacing "or" with "+"
    when adding values of a bitfield.
  * patches/documentation-formats.patch: new.  Provide a PDF version of
    the tutorial, and a text version of the programmer's guide, too.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat,  4 Aug 2007 18:52:26 +0200

gnat-gps (4.0.1-3) unstable; urgency=low
  
  * debian/gps.gpr: revert to -g -O2 -gnatafno -gnatVa and static
    elaboration checks.
  * patches/series (dynamically-tagged-expressions.patch): disable.
  * patches/documentation-path.patch: fix a bug whereby we would look for
    shell_commands.xml in the wrong directory.  This in turn fixes the
    Help menu.
  * patches/memory-corruption.patch: new.  Addresses: #400876, #400883,
    but does not close them yet because I think the underlying memory
    corruption bug is still lurking somewhere.

 -- Ludovic Brenta <lbrenta@debian.org>  Wed, 29 Nov 2006 22:01:50 +0100
  

gnat-gps (4.0.1-2) unstable; urgency=medium
  
  * debian/rules: install all the XML files that describe parts of the
    GUI.  Closes: #393636, insofar as I no longer see the crashes I
    described there.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 28 Nov 2006 22:14:37 +0100

gnat-gps (4.0.1-1) unstable; urgency=low
  
  * New upstream version.
  * patches/gtkada-2.8.1.patch: new.

 -- Ludovic Brenta <lbrenta@debian.org>  Mon, 27 Nov 2006 22:20:54 +0100

gnat-gps (4.0.0-1) unstable; urgency=low

  * New upstream version.
  * patches/gcc-4.1.patch: new.
  * patches/elaboration.patch: adjust for 4.0.0.
  * debian/rules (config.ads): replace the build date with "Debian".
    (binary-arch): adjust for images removed in this new version.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun, 26 Nov 2006 20:41:00 +0100

gnat-gps (3.1.3-5) unstable; urgency=low
  
  * patches/elaboration.patch: new, a step in resolving #393636.

 -- Ludovic Brenta <lbrenta@debian.org>  Fri, 10 Nov 2006 14:59:12 +0100

gnat-gps (3.1.3-4) unstable; urgency=low
  
  * debian/control (Build-Depends): add debhelper and quilt.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun, 15 Oct 2006 12:55:47 +0200

gnat-gps (3.1.3-3) unstable; urgency=low
  
  * debian/control (Build-Depends-Indep): new; move some build dependencies
    there from Build-Depends.  Add tetex-extra (Closes: #392375).
    (Build-Depends): remove libxmlada2-dev.
  * patches/texinfo.patch: fix the info-dir-section of the tutorial
    (Closes: #391972).  Also, change the name of the info file to
    gps_tutorial.info, to prevent conflicts with other packages.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 14 Oct 2006 17:03:58 +0200

gnat-gps (3.1.3-2) unstable; urgency=low
  
  * debian/control (Build-Depends): add libgnatprj-dev, libgnatvsn-dev, and
    libtemplates-parser-dev.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun,  8 Oct 2006 16:39:07 +0200

gnat-gps (3.1.3-1) unstable; urgency=low

  * New upstream version.
    - debian/297980.patch: remove, applied upstream.
    - debian/03-command-line.patch: remove, no longer applies.
    - debian/10-project-creation-wizard.patch: remove, no longer applies.
    - gps.gpr (Source_Dirs): adjust.  Also, use all libraries.
    - debian/rules (DIRS_WITH_C_SOURCES, gvd/common/gvd.ads): adjust.
    - No longer contains a partial copy of GNAT sources:
      . debian/01-libgnat-extras.patch: remove.
      . debian/02-use-libgnat-extras.patch: remove.
      . remove CONFLICTING_GNAT_SOURCES and related targets from debian/rules.
    - No longer contains cschtml:
      . remove debian/323515.patch
      . remove debian/09-cschtml.patch
      . remove CSCHTML_OBJECTS and related targets from debian/rules.
  * Switch to GCC 4.1 as the default Ada compiler.
    - debian/226513-pretty-printer.patch: remove, GCC 4.1 supports the
      pretty printer feature.
    - patches/gcc-4.1.patch: new.
  * debian/control (Maintainer): update email address, I'm now a full DD.
    (Uploaders): remove, no longer necessary.
    (Build-Depends): gnat (>= 4.1), libgkada2 (>= 2.8.1), libasis-dev,
    libtemplates-parser-dev, libgnatvsn-dev, libgnatprj-dev, quilt,
    tcl8.4-dev instead of tcl8.3-dev,
    python-dev instead of python2.3-dev.


=== debian/control ===
Source: gnat-gps
Section: devel
Priority: optional
Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
Build-Depends: gnat (>= 4.3), libgnatprj-dev, libgnatvsn-dev, python2.5-dev,
 libtemplates-parser-dev (>= 11.1), libgtkada2-dev (>= 2.12.0-2), tcl8.4-dev, 
 libcairo2-dev, debhelper (>= 4.2.13), quilt, gnat-4.3 (>= 4.3.1-2)
Build-Depends-Indep: debhelper (>> 4.2.13), texinfo, texlive-base-bin,
 texlive-fonts-recommended, texlive-latex-base, imagemagick, quilt,
 texlive-generic-recommended
Standards-Version: 3.7.2

Package: gnat-gps
Architecture: alpha amd64 hppa i386 ia64 kfreebsd-i386 lpia mips mipsel powerpc ppc64 s390 sparc
Depends: ${shlibs:Depends}
Recommends: gnat (>= 4.3), gdb (>= 6.8),
 gnat-gps-doc (= ${source:Version}), ada-reference-manual
Description: The GNAT Programming System - advanced IDE for C and Ada
 GPS is a complete integrated development environment that gives access
 to a wide range of tools and integrates them smoothly.
 .
 GPS gives access to built-in file editing; HTML based help system;
 complete compile/build/run cycle; intelligent source navigation;
 project management; general graph technology giving access to many
 different browsers such as source dependency, project dependency, call
 graphs, etc.; fully integrated visual debugger, based on the GVD
 technology, and enhanced for inclusion in GPS; generic version control
 system, providing access to CVS, ClearCase, and possibly others in the
 future; many other tools such as a visual comparison, automatic
 generation of files, source reformatting.
 .
 GPS is fully customizable, providing several levels of customizations:
 a first level, available through the preferences dialog; a second
 level, which allows you to customize your menu items, tool bar and key
 bindings; a third level, which allows you to automate processing
 through scripts; and a fourth level, which allows any kind of very
 specific or tight integration, due to the open nature of GPS, and to
 its architecture.
 .
 GPS also integrates with existing editors such as Emacs and Vi.

Package: gnat-gps-doc
Architecture: all
Section: doc
Description: The GNAT Programming System - documentation
 This package contains the documentation for GPS, the GNAT Programming
 System, in ASCII, Info, HTML and PostScript formats.  This documentation
 consists of:
 .
  - the GPS Tutorial: building Hello, World with the GPS
  - a User's Guide: using the GPS for multi-language projects
  - a Programmer's Manual: extending the GPS with new modules

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for gnat-gps.
# Copyright (c) 2003, 2004, 2005, 2006 Ludovic Brenta <lbrenta@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# The full text of the GNU General Public License is in the file
# /usr/share/common-licenses/GPL on Debian systems.

export DH_COMPAT = 4
ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
OS = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
CPUS := $(shell getconf _NPROCESSORS_ONLN)
CFLAGS := -g -O2
GTKCFLAGS := $(shell pkg-config --cflags-only-I gtk+-2.0)
PYTHONCFLAGS := -I/usr/include/$(shell pyversions -d)

regexp := ^Version: ([^.]+)\.([^.]+)\.([^.]+)-(.*)
major := $(shell dpkg-parsechangelog | grep "^Version: " | sed -r 's/$(regexp)/\1/')
minor := $(shell dpkg-parsechangelog | grep "^Version: " | sed -r 's/$(regexp)/\2/')
micro := $(shell dpkg-parsechangelog | grep "^Version: " | sed -r 's/$(regexp)/\3/')
upload := $(shell dpkg-parsechangelog | grep "^Version: " | sed -r 's/$(regexp)/\4/')

patch-stamp:
	dh_testdir
	-quilt push -a

unpatch:
	dh_testdir
	-quilt pop -a

SN := kernel/src_info/sn/snsrc
CBROWSER := $(SN)/snavigator/parsers/cpp/cbrowser
DBIMP := $(SN)/snavigator/db/dbimp

build: patch-stamp gnat-gps $(CBROWSER) $(DBIMP)

GENERATED_FILES := common/src/config.ads

gnat-gps: patch-stamp
gnat-gps: $(GENERATED_FILES) obj/libgps.a obj/libdb.a
	gnatmake -j$(CPUS) -Pgps.gpr

common/src/config.ads: common/src/config.ads.in
	sed -e 's/@GPS_VERSION@/$(major).$(minor).$(micro)/' \
	    -e 's/@TARGET@/$(OS)/' \
	    -e 's!@prefix@!/usr!' \
	    -e 's/@HOST_TYPE@/Unix/' \
	    -e 's/@STRIP_CR@/False/' \
	    -e 's/@CAN_OUTPUT@/True/' \
	    -e 's/@EXEC_COMMAND@/sh -c/' \
	    -e 's/@DEFAULT_FONT@/Sans 9/' \
	    -e 's/@DEFAULT_PS@/ps/' \
	    -e 's/@PRINT_CMD@/lpr/' \
	    -e 's/@OPAQUE_MDI@/True/' \
	    -e 's/@DIFF_CMD@/diff -u/' \
	    -e 's/@EXECUTION_WINDOW@/True/' \
	    -e "s/unknown date/Debian/" < $< > $@

# How to create the libraries:

HYPER := $(SN)/snavigator/hyper
DB := $(SN)/db
LIBDB := $(DB)/PORT/libdb.a

obj/libdb.a: $(LIBDB)
	ln $< $@

# The only place where we do a recursive make.
$(LIBDB):
	cd $(DB); ./configure; $(MAKE)

# Now we compile the other C language source files, and put them all
# together in one library, libgps.a.

DIRS_WITH_C_SOURCES := codefix/src common/gnat common/src gbuilder/pixmaps \
gnatlib/src gvd/pixmaps kernel/src_info/sn/src prj_editor/src prj_editor/pixmaps \
python/src vcs/pixmaps vdiff/src widgets/src
C_SOURCES := $(wildcard $(foreach dir,$(DIRS_WITH_C_SOURCES),$(dir)/*.c))
C_OBJECTS := $(patsubst %.c,%.o,$(C_SOURCES))

obj/libgps.a: $(C_OBJECTS)
	ar rcf $@ $^
	ranlib $@

# The individual objects in libgps.a.  Some object files require
# special rules to build.

kernel/src_info/sn/src/db_capi.o: kernel/src_info/sn/src/db_capi.c $(LIBDB)
	gcc -c $< -o $@ $(CFLAGS) -I$(DB) -I$(DB)/include -I$(HYPER)

gbuilder/src/utils.o: gbuilder/src/utils.c
	gcc -c $< -o $@ $(CFLAGS) $(GTKCFLAGS)

common/gnat/gexpect_tty.o: common/gnat/gexpect_tty.c
	gcc -c $< -o $@ $(CFLAGS) '-DSYSTEM_INCLUDE="system/gnu-linux.h"'

python/src/python_support.o: python/src/python_support.c
	gcc -c $< -o $@ $(CFLAGS) $(GTKCFLAGS) $(PYTHONCFLAGS)

widgets/src/%.o: widgets/src/%.c
	gcc -c $< -o $@ $(CFLAGS) $(GTKCFLAGS)

# Default rule, sufficient for most C files
%.o: %.c
	gcc -c $< -o $@ $(CFLAGS)

$(CBROWSER) $(DBIMP): $(SN)/snavigator/Makefile
	$(MAKE) -C $(SN)/snavigator

$(SN)/snavigator/Makefile: $(SN)/snavigator/Makefile.in
	cd $(SN)/snavigator; ./configure --prefix=/usr \
	   --with-tclconfig=/usr/lib/tcl8.4 \
	   --with-tclinclude=/usr/include/tcl8.4

manuals := gps gps_pg tutorial

docs: docs/Makefile $(foreach m,$(manuals),docs/$(m).info)
	$(MAKE) -C docs

docs/Makefile: docs/Makefile.in
	sed -e 's,@prefix@,/usr,' -e 's,@MAKEINFO@,makeinfo,' \
	    -e 's,@TEXI2DVI@,texi2dvi,' -e 's,@INSTALL@,install,' \
	    -e 's,@INSTALL_DATA@,install -m 644,' < $< > $@

docs/%.info: docs/%.texi
	makeinfo --no-split -o $@ $<

SNAVIGATOR_GENERATED_FILES = hyper/Makefile install/Makefile

PARSERS_GENERATED_FILES = \
assembly/ppc601-eabi/Makefile assembly/ppc601-eabi/config.h \
assembly/ppc601-eabi/config.log assembly/ppc601-eabi/config.status \
assembly/ppc601-eabi/stamp-h cpp/cbrowser cpp/cpplib/Makefile cpp/Makefile \
Makefile

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f gps-main gnat-gps obj/* $(LIBDB)
	-$(MAKE) -C docs distclean
	rm -f docs/*.pdf docs/*.info docs/*.txt
	rm -f $(GENERATED_FILES) $(C_OBJECTS) gps.log
	for dir in $(DB) $(SN)/snavigator; do \
	   if [ -f $$dir/Makefile ] ; then $(MAKE) -C $$dir distclean; fi; \
	done
	cd $(SN)/snavigator/parsers; rm -f $(PARSERS_GENERATED_FILES)
	cd $(SN)/snavigator; rm -f $(SNAVIGATOR_GENERATED_FILES)
	rm -f $(DB)/include/Makefile
	dh_clean

binary-indep: docs
	dh_testdir
	dh_testroot
	dh_installinfo -pgnat-gps-doc docs/*.info
	dh_install -pgnat-gps-doc \
		docs/gps/* \
		/usr/share/doc/gnat-gps-doc/html/
	dh_install -pgnat-gps-doc \
		$(foreach m,$(manuals),docs/$(m).pdf) \
		/usr/share/doc/gnat-gps-doc/pdf
	dh_install -pgnat-gps-doc \
		$(foreach m,$(manuals),docs/$(m).txt) \
		/usr/share/doc/gnat-gps-doc/txt
	dh_installdocs -pgnat-gps-doc \
		docs/*.html \
		docs/*.gif \
		docs/*.jpg \
		docs/*.xml
	dh_installexamples -pgnat-gps-doc examples/*
	dh_installchangelogs -i
	dh_fixperms -i
	dh_compress -pgnat-gps-doc -X.xml -X.ads -X.adb -X.c -X.py -X.pdf
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build
	dh_testdir
	dh_testroot
	dh_installdirs usr/bin usr/lib/gps \
		usr/share/gps/customize usr/share/doc/gnat-gps \
		usr/share/gps/icons usr/share/gps/python \
		usr/share/make
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install gnat-gps usr/bin
	dh_install $(DBIMP) usr/lib/gps
	dh_install $(CBROWSER) usr/lib/gps
	dh_install docs/*.png usr/share/gps
# Upstream ships many files with executable permission, lintian complains
	chmod u=rw,go=r debian/gnat-gps/usr/share/gps/*.*
	dh_install share/* usr/share/gps
	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman debian/gnat-gps.1
#	dh_link
	dh_strip
	dh_compress -X.py
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary docs

## gnat-gps 4.3

=== gnatlib/Makefile ===
--- 
+++ 
@@ -60,7 +60,7 @@
 endif
 	${MAKE} -C src -f Makefile.postgres install
 	${MAKE} -C src -f Makefile.tools install
-	${INSTALL} distrib/gnatcoll_gps.xml ${datadir}/gps/plug-ins
+	${CP} distrib/gnatcoll_gps.xml ${datadir}/gps/plug-ins
 	${CP} distrib/*.gpr ${libdir}/gnat
 
 install_static:

=== gps/Makefile ===
default build compile link ada c c++ clean internal-clean :
	$(MAKE) -s -f Makefile.gps $@

=== gnatlib/examples/Makefile ===
include ../Makefile.conf

ADA_PROJECT_PATH:=${prefix}/lib/gnat${DIRSEP}${ADA_PROJECT_PATH}${DIRSEP}../src
LD_LIBRARY_PATH:=${prefix}/lib:${LD_LIBRARY_PATH}
export ADA_PROJECT_PATH
export LD_LIBRARY_PATH

all:
	@${MKDIR} obj
	gnatmake -Pexamples
ifeq ($(WITH_GTK),yes)
	gnatmake -Pexamplesgtk
endif
	@echo "==================================================="
	@echo "== To run, set the environment variable LD_LIBRARY_PATH"
	@echo "==   LD_LIBRARY_PATH=${prefix}/lib/gnat:\$$LD_LIBRARY_PATH"

clean:
	gnatclean -q -Pexamples
ifeq ($(WITH_GTK),yes)
	gnatclean -q -Pexamplesgtk
endif

=== debian/changelog ===
gnat-gps (4.3-5ubuntu3) natty; urgency=low

  * Recommend: on ada-reference-manual-text rather than the NBS
    ada-reference-manual .

 -- Bilal Akhtar <bilalakhtar@ubuntu.com>  Wed, 24 Nov 2010 11:57:25 +0300

gnat-gps (4.3-5ubuntu2) natty; urgency=low

  * Rebuild for ada-reference-manual transition.
  * Update maintainer according to DebianMaintainerField spec.

 -- Bilal Akhtar <bilalakhtar@ubuntu.com>  Wed, 24 Nov 2010 11:16:21 +0300

gnat-gps (4.3-5ubuntu1) lucid; urgency=low

  * BUild on armel.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 15 Mar 2010 15:12:34 +0100

gnat-gps (4.3-5) unstable; urgency=low

  [Nicolas Boulenguez]
  * Switch to dpkg-source 3.0 (quilt) format.
  * control: (Standards-Version) upgraded without changes.
    (Build-Depends) quilt is not needed with this format.
  * rules: made linking with cairo and gtk explicit. Closes: #554643.

  [Ludovic Brenta]
  * debian/patches/add_project_file.patch, debian/rules: link against
    whichever version of libpython is the default.  Closes: #571489.

 -- Ludovic Brenta <lbrenta@debian.org>  Thu, 25 Feb 2010 23:32:43 +0100

gnat-gps (4.3-4) unstable; urgency=medium

  * debian/control (Architectures):
    - temporarily disable mips due to #566234, which affects
      libtemplates-parser, on which gnat-gps depends.

 -- Ludovic Brenta <lbrenta@debian.org>  Sun,  7 Feb 2010 23:02:28 +0100

gnat-gps (4.3-3) unstable; urgency=low
  
  * Added two patches
    - bug-567688.patch to fix termio.h problem, same bug as gnat-4.4 564232.
    Closes: #567668.
    - fix-config-guess.patch, config.guess from upstream didn't know about 
    GNU/kFreeBSD for uname -s.

 -- Xavier Grave <xavier.grave@ipno.in2p3.fr>  Sun, 31 Jan 2010 00:29:00 +0100
  

gnat-gps (4.3-2) unstable; urgency=low
  
  * debian/rules: do not build the doc as part of binary-arch.
    Closes: #567526.

 -- Ludovic Brenta <lbrenta@debian.org>  Fri, 29 Jan 2010 20:56:13 +0100
  

gnat-gps (4.3-1) unstable; urgency=low

  [Ludovic Brenta]
  * New version from upstream's Subversion repository, revision 131177
    (date: 2008-10-21T16:46:48) with additional changes as follows:
    - Pluck HA14-009 from the trunk and apply to the 4.3 branch, like AdaCore.
    - Pluck the fix for HA05-007 from the trunk.
    - Pluck the fix for D502-003 from the trunk.
    - Pluck the fix for E703-001 from the trunk.
    - Pluck fix for HB13-014 from the trunk.
    - Pluck fix for H904-015 from the trunk.
    - Pluck HB17-006 from the trunk.
    - Pluck HB04-009 from the trunk.
    - Pluck FB07-017 from the trunk.
    (for more details, see distrib/known-problems in the .orig.tar.gz and
    README.source)
  * debian/control (Build-Depends):
    - switch to gnat-4.4, libgnatvsn4.4-dev, libgnatprj4.4-dev. Closes: #560680.
    - switch to libgtkada2.14.2-dev and libtemplates-parser11.5-dev.
    - switch to debhelper version 7.
    (Depends): add ${misc:Depends} everywhere.
    (Standards-Version): bump to 3.8.3 with no changes required.
    (Architecture):
    - add kfreebsd-amd64.
    - remove alpha due to http://gcc.gnu.org/PR43072.
  * debian/compat: new, equal to 7.
  * debian/rules (DH_COMPAT): remove.
    - fix the parsing of the version from the changelog. Closes: #497596.
  * debian/patches/libgtkada2-2.14.2.patch: new.
  * debian/patches/no-gtkextra.patch: new, pluck revision 134974 from the trunk.
  * debian/menu: change Apps to Applications.  Closes: #530481.
  * debian/source.lintian-overrides: new.
  * debian/README.source: expand.
  * debian/copyright:
    - make machine-parseable (DEP5).
    - add copyright information for the bundled copy of Source Navigator
    - add copyright information for the bundled copy of Berkeley DB
  * debian/gnat-gps.install: also install features and known-problems into
    /usr/share/doc/gnat-gps.

  [Nicolas Boulenguez]
  * Moved patches to debian/patches and modified series to use patch without
    option -p0.  Closes: #538543.
  * rules: simplified with quit.make and separate debhelper files.
  * Replaced gps.gpr file with a patch creating it.
  * control:
    (Build-Depends) removed indirect redundancies.
    (Vcs-Browser,Vcs-Svn,Homepage) added.
  * copyright: versioned GPL
  * patches: documented each
  * lintian-overrides: accept empty dirs (for user hooks or example objects)
  * debian/README.source: expand.

 -- Ludovic Brenta <lbrenta@debian.org>  Fri, 29 Jan 2010 01:06:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,27 @@
 Source: gnat-gps
 Section: devel
 Priority: optional
-Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
-Build-Depends: gnat (>= 4.3), libgnatprj-dev, libgnatvsn-dev, python2.5-dev,
- libtemplates-parser-dev (>= 11.1), libgtkada2-dev (>= 2.12.0-2), tcl8.4-dev, 
- libcairo2-dev, debhelper (>= 4.2.13), quilt, gnat-4.3 (>= 4.3.1-2)
-Build-Depends-Indep: debhelper (>> 4.2.13), texinfo, texlive-base-bin,
- texlive-fonts-recommended, texlive-latex-base, imagemagick, quilt,
- texlive-generic-recommended
-Standards-Version: 3.7.2
+Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
+ Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+Build-Depends: gnat, gnat-4.4, libgnatprj4.4-dev, python-dev,
+ libtemplates-parser11.5-dev (>= 11.5-2), libgtkada2.14.2-dev, tcl8.4-dev,
+ debhelper (>= 7.0.50~)
+Build-Depends-Indep: texinfo,  imagemagick,
+ texlive-fonts-recommended, texlive-latex-base, texlive-generic-recommended
+Standards-Version: 3.8.4
+Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gnat-gps
+Vcs-Svn: http://svn.eu.adacore.com/anonsvn/Dev/trunk/gps
+Homepage: http://libre.adacore.com/libre/tools/gps
 
 Package: gnat-gps
-Architecture: alpha amd64 hppa i386 ia64 kfreebsd-i386 lpia mips mipsel powerpc ppc64 s390 sparc
-Depends: ${shlibs:Depends}
+Architecture: amd64 hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 s390 sparc armel
+# alpha is temporarily disabled due to #http://gcc.gnu.org/PR42073
+# mips  is temporarily disabled due to #http://bugs.debian.org/566234
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: gnat (>= 4.3), gdb (>= 6.8),
- gnat-gps-doc (= ${source:Version}), ada-reference-manual
+ gnat-gps-doc (= ${source:Version}), ada-reference-manual-text
 Description: The GNAT Programming System - advanced IDE for C and Ada
  GPS is a complete integrated development environment that gives access
  to a wide range of tools and integrates them smoothly.
@@ -40,8 +46,22 @@
  .
  GPS also integrates with existing editors such as Emacs and Vi.
 
+Package: gnat-gps-dbg
+Architecture: amd64 hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 s390 sparc armel
+# alpha is temporarily disabled due to #http://gcc.gnu.org/PR42073
+# mips  is temporarily disabled due to #http://bugs.debian.org/566234
+Priority: extra
+Section: debug
+Depends: gnat-gps (= ${binary:Version}), ${misc:Depends}
+Description: The GNAT Programming System - advanced IDE for C and Ada (debugging symbols)
+ GPS is a complete integrated development environment that gives access
+ to a wide range of tools and integrates them smoothly.
+ .
+ This package contains the detached debugging symbols for debugging GPS.
+
 Package: gnat-gps-doc
 Architecture: all
+Depends: ${misc:Depends}
 Section: doc
 Description: The GNAT Programming System - documentation
  This package contains the documentation for GPS, the GNAT Programming

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003, 2004, 2005, 2006 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2010 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

########################
# Guess some variables.
########################

ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
OS = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
.NOTPARALLEL:
# since gnatmake will do the job(s)
CPUS := $(shell getconf _NPROCESSORS_ONLN)
CFLAGS := -g -O2
GTKCFLAGS := $(shell pkg-config --cflags-only-I gtk+-2.0)
GTK_LARGS := $(shell pkg-config --libs gtk+-2.0 cairo-xlib-xrender)
DEFAULT_PYTHON := $(shell pyversions -d)
PYTHONCFLAGS := -I/usr/include/$(DEFAULT_PYTHON)

version := $(shell dpkg-parsechangelog | grep "^Version: " | sed -r 's/^Version: //')

SN := kernel/src_info/sn/snsrc
CBROWSER := $(SN)/snavigator/parsers/cpp/cbrowser
DBIMP := $(SN)/snavigator/db/dbimp

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

.PHONY: build binary binary-arch binary-indep clean install
binary: binary-arch binary-indep
binary-arch: gnat-gps $(CBROWSER) $(DBIMP)
binary-indep: docs
build binary-arch binary-indep clean install:
	dh $@

# Do not try to call an upstream configure or Makefile.
override_dh_auto_configure:
override_dh_auto_test:
override_dh_auto_install:

GENERATED_FILES := common/src/config.ads

# gnatmake knows if the file needs recompilation.
.PHONY: gnat-gps
gnat-gps: $(GENERATED_FILES) obj/libgps.a obj/libdb.a
	gnatmake -j$(CPUS) -Pgps.gpr -XDEFAULT_PYTHON=$(DEFAULT_PYTHON) -largs $(GTK_LARGS)

common/src/config.ads: common/src/config.ads.in
	sed -e 's/@GPS_VERSION@/$(version)/' \
	    -e 's/@TARGET@/$(OS)/' \
	    -e 's!@prefix@!/usr!' \
	    -e 's/@HOST_TYPE@/Unix/' \
	    -e 's/@STRIP_CR@/False/' \
	    -e 's/@CAN_OUTPUT@/True/' \
	    -e 's/@EXEC_COMMAND@/sh -c/' \
	    -e 's/@DEFAULT_FONT@/Sans 9/' \
	    -e 's/@DEFAULT_PS@/ps/' \
	    -e 's/@PRINT_CMD@/lpr/' \
	    -e 's/@OPAQUE_MDI@/True/' \
	    -e 's/@DIFF_CMD@/diff -u/' \
	    -e 's/@EXECUTION_WINDOW@/True/' \
	    -e "s/unknown date/Debian/" < $< > $@

# How to create the libraries:

HYPER := $(SN)/snavigator/hyper
DB := $(SN)/db-2.7.7
LIBDB := $(DB)/build_unix/libdb.a

obj/libdb.a: $(LIBDB)
	ln -f $< $@
$(LIBDB):
	cd $(DB)/build_unix && ../dist/configure --enable-compat185
	$(MAKE) -C $(DB)/build_unix

# Now we compile the other C language source files, and put them all
# together in one library, libgps.a.

DIRS_WITH_C_SOURCES := codefix/src codefix/ui/src common/src common/tty \
gbuilder/pixmaps gbuilder/src gnatlib/src gnatlib/src/gmp \
gnatlib/src/gtk/python gnatlib/src/python gvd/pixmaps kernel/src_info/sn/src \
prj_editor/src prj_editor/pixmaps vcs/pixmaps vdiff/src widgets/src
C_SOURCES := $(wildcard $(foreach dir,$(DIRS_WITH_C_SOURCES),$(dir)/*.c))
C_OBJECTS := $(patsubst %.c,%.o,$(C_SOURCES))

obj/libgps.a: $(C_OBJECTS)
	ar rcf $@ $^
	ranlib $@

# The individual objects in libgps.a.

# Default rule, sufficient for most C files
%.o: %.c
	gcc -c $< -o $@ $(CFLAGS)
# Some object files require special rules to build.
kernel/src_info/sn/src/db_capi.o: $(LIBDB)
kernel/src_info/sn/src/db_capi.o: CFLAGS += -I$(DB)/build_unix -I$(DB)/include -I$(HYPER)
gbuilder/src/utils.o: CFLAGS += $(GTKCFLAGS)
common/gnat/gexpect_tty.o: CFLAGS += '-DSYSTEM_INCLUDE="system/gnu-linux.h"'
gnatlib/src/python/python_support.o: CFLAGS += $(GTKCFLAGS) $(PYTHONCFLAGS)
gnatlib/src/gtk/python/python_support_gtk.o: CFLAGS += $(GTKCFLAGS) $(PYTHONCFLAGS)
widgets/src/%.o: CFLAGS += $(GTKCFLAGS)

$(CBROWSER) $(DBIMP): $(SN)/snavigator/Makefile
	$(MAKE) -C $(SN)/snavigator

$(SN)/snavigator/Makefile: $(SN)/snavigator/Makefile.in
	cd $(SN)/snavigator; ./configure --prefix=/usr \
	   --with-tclconfig=/usr/lib/tcl8.4 \
	   --with-tclinclude=/usr/include/tcl8.4

manuals := gps gps_pg tutorial

.PHONY: docs
docs: docs/Makefile $(foreach m,$(manuals),docs/$(m).info)
	$(MAKE) -C docs

docs/Makefile: docs/Makefile.in
	sed -e 's,@prefix@,/usr,' -e 's,@MAKEINFO@,makeinfo,' \
	    -e 's,@TEXI2DVI@,texi2dvi,' -e 's,@INSTALL@,install,' \
	    -e 's,@INSTALL_DATA@,install -m 644,' < $< > $@

docs/%.info: docs/%.texi
	makeinfo --no-split -o $@ $<

SNAVIGATOR_GENERATED_FILES = hyper/Makefile install/Makefile

PARSERS_GENERATED_FILES = \
assembly/ppc601-eabi/Makefile assembly/ppc601-eabi/config.h \
assembly/ppc601-eabi/config.log assembly/ppc601-eabi/config.status \
assembly/ppc601-eabi/stamp-h cpp/cbrowser cpp/cpplib/Makefile cpp/Makefile \
Makefile

override_dh_auto_clean:
	for dir in docs $(DB)/build_unix $(SN)/snavigator; do \
	   if test -f $$dir/Makefile; then \
              $(MAKE) -C $$dir distclean; \
           fi; \
        done;
	dh_clean \
           $(GENERATED_FILES) $(C_OBJECTS) \
           $(addprefix $(SN)/snavigator/parsers/, $(PARSERS_GENERATED_FILES)) \
           $(addprefix $(SN)/snavigator/, $(SNAVIGATOR_GENERATED_FILES))

override_dh_installdocs:
	dh_installdocs --all --link-doc=gnat-gps

override_dh_install:
	dh_install --all
	dh_install --package=gnat-gps $(DBIMP) $(CBROWSER) usr/lib/gps

override_dh_compress:
	dh_compress --all -X.xml -X.ads -X.adb -X.c -X.py

override_dh_strip:
	dh_strip --dbg-package=gnat-gps-dbg
